// This file is auto-generated, don't edit it. Thanks.
package com.aliyun.sample;

import com.aliyun.tea.*;
import com.aliyun.sample.models.*;
import com.aliyun.teaopenapi.*;
import com.aliyun.teaopenapi.models.*;
import com.aliyun.teautil.*;
import com.aliyun.teaconsole.*;
import com.aliyun.darabonba.env.*;
import com.aliyun.vod20170321.*;
import com.aliyun.vod20170321.models.*;

public class Sample {

    public static com.aliyun.vod20170321.Client initVodClient(String accessKeyId, String accessKeySecret, String regionId) throws Exception {
        Config config = new Config();
        config.accessKeyId = accessKeyId;
        config.accessKeySecret = accessKeySecret;
        config.regionId = regionId;
        return new com.aliyun.vod20170321.Client(config);
    }

    public static void main(String[] args_) throws Exception {
        java.util.List<String> args = java.util.Arrays.asList(args_);
        com.aliyun.vod20170321.Client client = Sample.initVodClient(com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_ID"), com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_SECRET"), args.get(0));
        // 构造模板组信息
        VideoInfo videoInfo = new VideoInfo()
                .setBitrate("128")
                .setCodec("H.264")
                .setRemove("false")
                .setWidth("640")
                .setFps("30");
        AudioInfo audioInfo = new AudioInfo()
                .setCodec("AAC")
                .setBitrate("128")
                .setRemove("false")
                .setSamplerate("44100");
        ContainerInfo containerInfo = new ContainerInfo()
                .setFormat("mp4");
        TranscodeTemplate transcodeTemplate = new TranscodeTemplate()
                .setVideo(videoInfo)
                .setAudio(audioInfo)
                .setContainer(containerInfo)
                .setDefinition("SD")
                .setTemplateName("test");
        java.util.List<TranscodeTemplate> anyArray = java.util.Arrays.asList(
            transcodeTemplate
        );
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(anyArray));
        // 1.添加转码配置信息
        AddTranscodeTemplateGroupRequest addTranscodeTemplateGroupRequest = new AddTranscodeTemplateGroupRequest()
                .setName(args.get(1))
                .setTranscodeTemplateList(com.aliyun.teautil.Common.toJSONString(anyArray));
        AddTranscodeTemplateGroupResponse addTranscodeTemplateGroupResponse = client.addTranscodeTemplateGroup(addTranscodeTemplateGroupRequest);
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(addTranscodeTemplateGroupResponse)));
        // 转码模板组id
        String uploadTranscodeTemplateGroupId = addTranscodeTemplateGroupResponse.body.transcodeTemplateGroupId;
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(uploadTranscodeTemplateGroupId));
        // 2.查询转码配置的详细信息
        GetTranscodeTemplateGroupRequest getTranscodeTemplateGroupRequest = new GetTranscodeTemplateGroupRequest()
                .setTranscodeTemplateGroupId(uploadTranscodeTemplateGroupId);
        GetTranscodeTemplateGroupResponse getTranscodeTemplateGroupResponse = client.getTranscodeTemplateGroup(getTranscodeTemplateGroupRequest);
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(getTranscodeTemplateGroupResponse)));
        // 3.查询转码模板配置列表
        ListTranscodeTemplateGroupRequest listTranscodeTemplateGroupRequest = new ListTranscodeTemplateGroupRequest();
        ListTranscodeTemplateGroupResponse listTranscodeTemplateGroupResponse = client.listTranscodeTemplateGroup(listTranscodeTemplateGroupRequest);
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(listTranscodeTemplateGroupResponse)));
        // 4.修改转码配置信息
        UpdateTranscodeTemplateGroupRequest updateTranscodeTemplateGroupRequest = new UpdateTranscodeTemplateGroupRequest()
                .setTranscodeTemplateGroupId(uploadTranscodeTemplateGroupId)
                .setName("transcodetemplate");
        UpdateTranscodeTemplateGroupResponse updateTranscodeTemplateGroupResponse = client.updateTranscodeTemplateGroup(updateTranscodeTemplateGroupRequest);
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(updateTranscodeTemplateGroupResponse)));
        // 5.设置默认转码模板配置
        SetDefaultTranscodeTemplateGroupRequest setDefaultTranscodeTemplateGroupRequest = new SetDefaultTranscodeTemplateGroupRequest()
                .setTranscodeTemplateGroupId(uploadTranscodeTemplateGroupId);
        SetDefaultTranscodeTemplateGroupResponse setDefaultTranscodeTemplateGroupResponse = client.setDefaultTranscodeTemplateGroup(setDefaultTranscodeTemplateGroupRequest);
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(setDefaultTranscodeTemplateGroupResponse)));
        // 设置转码模板为默认模板
        setDefaultTranscodeTemplateGroupRequest.transcodeTemplateGroupId = "VOD_NO_TRANSCODE";
        setDefaultTranscodeTemplateGroupResponse = client.setDefaultTranscodeTemplateGroup(setDefaultTranscodeTemplateGroupRequest);
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(setDefaultTranscodeTemplateGroupResponse)));
        // 6.删除转码配置信息
        DeleteTranscodeTemplateGroupRequest deleteTranscodeTemplateGroupRequest = new DeleteTranscodeTemplateGroupRequest()
                .setTranscodeTemplateGroupId(uploadTranscodeTemplateGroupId)
                .setForceDelGroup("true");
        DeleteTranscodeTemplateGroupResponse deleteTranscodeTemplateGroupResponse = client.deleteTranscodeTemplateGroup(deleteTranscodeTemplateGroupRequest);
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(deleteTranscodeTemplateGroupResponse)));
    }
}
